︠638597f0-a778-4e0b-b1f3-f34ec53a4c3fs︠
# how many numbers less than n are prime?
prime_pi(2017)
︡c04958a3-58e5-436a-8789-c5c358418a44︡{"stdout":"306\n"}︡{"done":true}
︠6b2b3e15-6044-4f80-9ac7-e1855e006f4fs︠
n=1000
stairs=[prime_pi(k) for k in [1..n]]
list_plot(stairs, plotjoined=true)
︡70a19729-972d-4904-b1f7-c80f301ea713︡{"file":{"filename":"/projects/2ad65871-00da-4e99-b1a6-6cbf035f8bc5/.sage/temp/compute2-us/14876/tmp_w697g1.svg","show":true,"text":null,"uuid":"68caf9fa-f5ff-4310-9aea-1355b93e0340"},"once":false}︡{"done":true}︡
︠6485b18e-2505-4a43-8f79-6755daf52e0e︠

︡0a625445-a62f-4325-a31c-8390302c2f14︡
︠1a9b5a5d-de4e-4bba-99ce-5d8dd9b0ff10s︠
next_prime(2017)
︡3b293482-18df-4de1-8bac-d31dd109bc7b︡{"stdout":"2027\n"}︡{"done":true}︡
︠a144c849-cbe6-4a1b-9ef4-000ab2ebab01s︠
n=2000
︡9dec1ace-434a-44e2-a144-7f623d86c295︡{"done":true}︡
︠80b502be-b6d9-4b1d-bd49-4b7d200fafd9s︠
n.is_square()
︡7b5eb90e-c4d0-45f4-aacf-9643913966d5︡{"stdout":"False\n"}︡{"done":true}︡
︠56ed1078-8728-4355-8420-f8e142222a13s︠
nsq=0
npr=0
for n in [1..1000]:
    if n.is_square():
        nsq += 1
    if n.is_prime():
        npr +=1
︡d1ebc8d9-5076-472b-852a-c1f25f3363ab︡{"done":true}︡
︠8b84e2a7-261c-473d-b980-48b3ef8c66bcs︠
npr, nsq    
︡b51c055b-4fae-42a9-8a42-5e4814a18695︡{"stdout":"(168, 31)\n"}︡{"done":true}︡
︠1b05eebc-4d93-4eb4-b367-41de5385d693s︠
prime_pi(1000)
︡4c1ca5a6-8480-433d-add4-4aed49016f2f︡{"stdout":"168\n"}︡{"done":true}︡
︠0f92e995-4359-40c0-9661-c4bf76d8ef1fs︠
#the algorithm that never stops outputting primes.  
#we do it for just 10 steps, and it gives us 10 distinct primes
steps = 10
atoms =[2] #the first prime
for k in range(steps):
    #take product of all atoms, add 1; call it q
    pr=1
    for a in atoms:
        pr *= a
    q = pr +1
    if q.is_prime():
        # if q is a prime, append it to our list
        atoms.append(q)
    else: #otherwise, q factors, and append its least prime factor to our list
        atoms.append(min(q.prime_factors()))
#Now, print out the list of primes we found
atoms
︡8c99ea77-a9db-4eb8-93e3-2aa71897007e︡{"stdout":"[2, 3, 7, 43, 13, 53, 5, 6221671, 38709183810571, 139, 2801]\n"}︡{"done":true}︡
︠ef9dd908-4c7a-4b02-8bfd-2ded9b8a85da︠
#the song!
n=8675309
n.is_prime()
︡aa0b1d49-0090-4187-af5c-fd4649799448︡{"stdout":"True\n"}︡{"done":true}︡
︠ef395f32-9e65-452d-8e26-013de9a46e95s︠
n=15 #size of grid
nticks =15 #number of ticks to mark on axes
d=ceil(n/nticks) #spacing between ticks

#create a matrix of 0,1 values depending on whether x is relatively prime to y
#recall that "!=" is the python symbol for not equals.  We could use "==" for logical equals but I like the colors better this way.
m = [[gcd(x,y) != 1 for x in [1..n]] for y in [1..n]]

#now we draw the matrix.  The 'origin' option places the lower values on the lower left (default is upper left)
#the 'ticks' and 'tick-formatter' stuff is designed to get the labeling right.  If you leave it off, you get Python
#defaults starting from zero
#Also note the "cmap" command which picks a nice color scheme.  Sage has a few default color schemes; look them up.
#You can load a huge collection of color schemes as well with the command 'import matplotlib.cm' and if you
#want to see the list of color maps, type 'matplotlib.cm.datad.keys()'
#finally, the option 'figsize' allows you to get a larger figure, duh.  good for large n. If you omit it you get a default size which is fine.
matrix_plot(m,origin='lower',ticks=[range(0,n,d),range(0,n,d)],tick_formatter=[range(1,n+1,d),range(1,n+1,d)],cmap='winter', figsize=8)
︡5e6bcc7e-d660-4879-80bc-613589e0c2b0︡{"file":{"filename":"/projects/2ad65871-00da-4e99-b1a6-6cbf035f8bc5/.sage/temp/compute2-us/29052/tmp_yRr3pw.svg","show":true,"text":null,"uuid":"a3d21d54-d546-4c99-a841-72773f423f9f"},"once":false}︡{"done":true}︡
︠c2226086-11eb-4f57-a68b-0d0643ebf494s︠
n=29 #size of grid


#create a matrix of 0,1 values depending on whether x is relatively prime to y
m = [[gcd(x,y)==1 for x in [1..n]]for y in [1..n]]
#here is a matrix plot with no tickmarks.  the way you do this is by declaring ticks that are outside the actual range
#(i.e., greater than n).  It is stupid, but it works.  It took me a long time to discover this trick.
matrix_plot(m,origin='lower',ticks=[range(2*n,3*n),range(2*n,3*n)])
︡523ba53c-3372-4eae-ae77-8d65115405f5︡{"file":{"filename":"/projects/2ad65871-00da-4e99-b1a6-6cbf035f8bc5/.sage/temp/compute2-us/9100/tmp_WB1ohh.svg","show":true,"text":null,"uuid":"272e4358-3727-436d-a2f0-b88f27ee0861"},"once":false}︡{"done":true}︡
︠ec95f036-0d90-4dfe-ab1d-8e4d377e41ca︠
n=10 #size of grid



m = [[gcd(x,y) for x in [1..n]]for y in [1..n]]
#here is a matrix plot with no tickmarks.  the way you do this is by declaring ticks that are outside the actual range
#(i.e., greater than n).  It is stupid, but it works.  It took me a long time to discover this trick.
matrix_plot(m,origin='lower',ticks=[range(2*n,3*n),range(2*n,3*n)], cmap='rainbow',colorbar=true)
︡3a02a4fb-1223-46cf-bcbd-95795f7696c8︡
︠3ececa6e-816c-4251-95e6-7926c3b8940fs︠
################
# GCD calculations
gcd(30,200)
︡f71d0bea-e6a0-4529-86e7-af4f39d3cad3︡{"stdout":"10\n"}︡{"done":true}︡
︠253459be-9f73-4996-bd6a-a3afa38eab13s︠
xgcd(30,200)
︡0507c10c-30f7-4aa8-95e1-8e019d7ad294︡{"stdout":"(10, 7, -1)\n"}︡{"done":true}︡
︠cf733901-980c-45ef-92af-27ce339495ees︠
#implement Euclidean Algorithm and count number of steps
def EALength(a,b):
    #count number of steps in Euclidean Algorithm
    #if a<b then switch em
    if a < b:
        temp = a
        a = b
        b = temp
        
    r=b
    steps =0
    while r>0:
        temp = b
        r = a% b
        a = temp
        b = r
        steps += 1
    return steps
︡66af5cb3-5afe-4fee-8f3b-9646a63097d8︡{"done":true}︡
︠50903f81-dfdf-4b2d-a0db-1357352684d1s︠
n=90 #size of grid


#create a matrix of values for EALength
m = [[EALength(x,y) for x in [1..n]]for y in [1..n]]
#here is a matrix plot with no tickmarks.  the way you do this is by declaring ticks that are outside the actual range
#(i.e., greater than n).  It is stupid, but it works.  It took me a long time to discover this trick.
matrix_plot(m,origin='lower',ticks=[range(2*n,3*n),range(2*n,3*n)],cmap='winter',colorbar=true)
︡62e83c10-5386-4fe2-9add-5d0db46fcc7e︡{"file":{"filename":"/projects/2ad65871-00da-4e99-b1a6-6cbf035f8bc5/.sage/temp/compute4-us/32305/tmp_v0eK3F.svg","show":true,"text":null,"uuid":"86be8564-9259-4f72-bbc9-6dc99243dbb8"},"once":false}︡{"done":true}︡
︠f6eb3056-b0c1-4201-83ba-9876141c066bs︠


sigma(5,1)
︡18d2f660-2767-4607-a4ac-f09105ee44ae︡{"stdout":"6\n"}︡{"done":true}︡
︠be54d64f-b235-47e8-95be-6f246acda3efs︠
sigma(10,0)
︡6b5eb7e4-5c1d-4675-aff5-e45a3791ce6a︡{"stdout":"4\n"}︡{"done":true}︡
︠6e5e1ae8-a379-43bd-82f2-d18c9e3e63c5s︠
Mod(5, 12)
︡7dd9d01b-52c0-44d8-b209-fbfacb1a5f15︡{"stdout":"5\n"}︡{"done":true}︡
︠4d1b89ff-5d5d-4798-afcc-bbf25c7fb63ds︠
a= mod(3,7)
︡335ba094-5569-4a44-91ae-560f40e5f128︡{"done":true}︡
︠1d4f3d22-7388-4d92-bf7c-f6ef9e8d64c7s︠
a
︡3adaadd1-38b2-4d73-ba03-35350c15383f︡{"stdout":"3\n"}︡{"done":true}︡
︠27430f1d-4648-4788-93aa-45b161174c5bs︠
a^100
︡ecc850b0-bf63-4b25-9754-9ecd2037adfb︡{"stdout":"4\n"}︡{"done":true}︡
︠e5eeae21-5225-43db-8fd1-bf52876b7972s︠
3^100
︡fddcba55-ccd8-4bf5-b8b1-217a0d63ad0a︡{"stdout":"515377520732011331036461129765621272702107522001\n"}︡{"done":true}︡
︠f1c01f78-af26-4e78-b322-8afcc0aa6a96s︠
1/a
︡e24f5666-3a68-4db5-b3b0-63f8efe175ca︡{"stdout":"5\n"}︡{"done":true}︡
︠eefb6a82-f7f8-48e9-9656-1e720a659feds︠
b=mod(-1,17)
︡e7869dd8-6e68-4c07-9127-9daff6a76a81︡{"done":true}︡
︠71d0d4ae-9986-4989-9c99-b914242bfc76s︠
sqrt(b)
︡48f392b2-ab60-4814-a447-438522b88a38︡{"stdout":"4\n"}︡{"done":true}︡
︠8e2691fe-4f97-4f4b-a4b3-ba446503dde1s︠
c=mod(3,12)
︡c8c6a08e-48c4-414a-b470-a868280c7136︡{"done":true}︡
︠89724e27-d942-4e28-9aea-df947b225cbes︠
1/c
︡cf55afb4-1de9-49c3-9853-d2ac290bddd4︡{"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/projects/sage/sage-7.5/local/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 982, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\n  File \"sage/rings/integer.pyx\", line 1858, in sage.rings.integer.Integer.__div__ (/projects/sage/sage-7.5/src/build/cythonized/sage/rings/integer.c:13046)\n    return coercion_model.bin_op(left, right, operator.div)\n  File \"sage/structure/coerce.pyx\", line 1055, in sage.structure.coerce.CoercionModel_cache_maps.bin_op (/projects/sage/sage-7.5/src/build/cythonized/sage/structure/coerce.c:9336)\n    return PyObject_CallObject(op, xy)\n  File \"sage/structure/element.pyx\", line 1638, in sage.structure.element.Element.__div__ (/projects/sage/sage-7.5/src/build/cythonized/sage/structure/element.c:12978)\n    return (<Element>left)._div_(right)\n  File \"sage/rings/finite_rings/integer_mod.pyx\", line 2430, in sage.rings.finite_rings.integer_mod.IntegerMod_int._div_ (/projects/sage/sage-7.5/src/build/cythonized/sage/rings/finite_rings/integer_mod.c:28670)\n    raise ZeroDivisionError(\"Inverse does not exist.\")\nZeroDivisionError: Inverse does not exist.\n"}︡{"done":true}︡
︠5cf5b5bd-37d9-4dc1-a672-ba658152cd78s︠


a=mod(2, 645)
︡d5cab4c1-d060-41d0-9c83-21ff546381f2︡{"done":true}︡
︠cb007ddf-1111-4fed-8ef0-e2bef811c8f4s︠
a^644
︡fed48f03-9828-49e7-91ee-d2923657ca63︡{"stdout":"1\n"}︡{"done":true}︡
︠6bb4f769-40bc-46d5-9bca-b2001a46aec2s︠
factor(644)
︡8032efef-95f5-4d39-992d-85043ecd923e︡{"stdout":"2^2 * 7 * 23\n"}︡{"done":true}︡
︠e888fefe-31b0-4ebb-b629-6484f3c8b1c0s︠
a^14
︡b94a6087-5cb0-40eb-acdc-53232787cc2c︡{"stdout":"259\n"}︡{"done":true}︡
︠95c7489e-24bb-4de9-b60b-da17f50bb7e4s︠
a^7
︡6556cb31-a330-4fea-9bb7-b3279378cf13︡{"stdout":"128\n"}︡{"done":true}︡
︠4e8e5429-0e8e-4550-a188-7fc8f44c9c17s︠
a^28
︡f45d9f9d-f4a0-4fe7-b2a4-844012bf9a66︡{"stdout":"1\n"}︡{"done":true}︡
︠1c12fddd-a535-43e0-baa7-47fa8367163es︠
euler_phi(645)
︡ac340784-1f13-4891-8ea8-becab66c1285︡{"stdout":"336\n"}︡{"done":true}︡
︠62bcd1a6-fa5b-4916-93b6-f1d43e58d25es︠
a^336
︡619072cd-b92b-4321-8223-ac1c84b3ba53︡{"stdout":"1\n"}︡{"done":true}︡
︠008b9f71-75b7-4cd9-9780-363b46b5078as︠
factor(336)
︡8287d4a3-bc81-42f2-974d-8f8a2dfc46ac︡{"stdout":"2^4 * 3 * 7\n"}︡{"done":true}︡
︠0907dc7d-b53a-4efb-a334-28182b9c3231s︠
xgcd(27720,13)
︡e6a9b667-703a-4624-a219-d05dd2fae766︡{"stdout":"(1, -3, 6397)\n"}︡{"done":true}︡
︠fd525815-ff73-4108-b099-e03d24b0c515s︠
13*6397
︡72bdca1f-4fe1-469c-8168-04f941c596b8︡{"stdout":"83161\n"}︡{"done":true}︡
︠2c21fae2-2b19-4676-99bf-5e4f68d9ab7fs︠
mod(83161,27720)
︡f052ef6d-1647-43fb-bb97-faa6cbd667a4︡{"stdout":"1\n"}︡{"done":true}︡
︠a48104e7-850a-47f7-990f-ca8e9ab634ces︠
-27720*3
︡493576fe-fc87-423d-9609-d3cb657dced6︡{"stdout":"-83160\n"}︡{"done":true}︡
︠14eb01e2-f6cb-415f-a55a-adb192502eb2s︠
mod(-83160,27720*13)
︡9df77d15-a797-4ffb-899b-0c1c3e863c0c︡{"stdout":"277200\n"}︡{"done":true}︡
︠935d189d-31b3-4c5d-a943-a06f8027bcf2s︠
mod(277200,13)
︡3b914915-91d5-4c03-a1b1-8db12e2de593︡{"stdout":"1\n"}︡{"done":true}︡
︠df361907-9933-43e3-b23b-607f2eb7528as︠
crt(1,2,3,4)
︡def6986f-79d2-4655-8461-7a01d3ca3318︡{"stdout":"10\n"}︡{"done":true}︡
︠8d5fd84f-7498-4e54-b97b-f7c8ccd2c369ss︠
a=crt(0,-1,2,3)
︡ebb1b404-52f1-4346-9a21-682a6d57450d︡{"done":true}︡
︠7041295f-d30f-41c6-b8b4-ac822647667bs︠
is_prime(219)
︡cd9fb7ae-2a08-42dd-b3d7-9cd0d686faa7︡{"stdout":"False\n"}︡{"done":true}︡
︠aa85ebdd-4521-4cd8-ace8-a9659e6ad015s︠
factor(219)
︡2609d515-75a6-45c2-925e-113c28526821︡{"stdout":"3 * 73\n"}︡{"done":true}︡
︠ca8853a1-2c3f-4263-a314-faecd720c85ds︠
crt(32,-5,30,7)
︡c5690e8f-2776-4ad2-b883-56bff6472cdd︡{"stdout":"2\n"}︡{"done":true}︡
︠33f6a222-b4f8-48e5-8e8e-020d11096e6ds︠
210*11+2
︡9d8d9e7b-d717-4b8f-a2a1-6c239582cc02︡{"stdout":"2312\n"}︡{"done":true}︡
︠431b531e-4816-430b-85fc-181ef5aa698bs︠
for k in [888..888+19]:
    print k, factor(k)
︡3a63f652-037d-4797-abd4-8609b301a07a︡{"stdout":"888 2^3 * 3 * 37\n889 7 * 127\n890 2 * 5 * 89\n891 3^4 * 11\n892 2^2 * 223\n893 19 * 47\n894 2 * 3 * 149\n895 5 * 179\n896 2^7 * 7\n897 3 * 13 * 23\n898 2 * 449\n899 29 * 31\n900 2^2 * 3^2 * 5^2\n901 17 * 53\n902 2 * 11 * 41\n903 3 * 7 * 43\n904 2^3 * 113\n905 5 * 181\n906 2 * 3 * 151\n907 907\n"}︡{"done":true}︡
︠4b6ecd2e-46f3-4816-92a1-a6f2ea13362ds︠
length = 35
for start in range(10000):
    prod=1
    for k in [start..start+length-1]:
        prod *= 1-is_prime(k)
    if prod==1:
        print start


︡711d65a3-1ba4-43f6-a996-33ea865e1b38︡{"stdout":"9552"}︡{"stdout":"\n"}︡{"done":true}︡
︠765ee013-8142-463b-bc6f-ab0a0d21cf4as︠
crt(11, 19, 17,50)    
︡2487b05d-b08f-4c81-9b75-75f61e153cb2︡{"stdout":"419\n"}︡{"done":true}︡
︠4fd6433b-0bc0-4e05-9cce-03cbb06c3624s︠
f(x)=x/(2-3*x+x^2)
f.taylor(x,0,18)
︡bc6b9268-adf3-4417-81aa-98020fa1fc0c︡{"stdout":"x |--> 262143/262144*x^18 + 131071/131072*x^17 + 65535/65536*x^16 + 32767/32768*x^15 + 16383/16384*x^14 + 8191/8192*x^13 + 4095/4096*x^12 + 2047/2048*x^11 + 1023/1024*x^10 + 511/512*x^9 + 255/256*x^8 + 127/128*x^7 + 63/64*x^6 + 31/32*x^5 + 15/16*x^4 + 7/8*x^3 + 3/4*x^2 + 1/2*x\n"}︡{"done":true}︡
︠6563720b-66e1-4584-820e-378258e04150s︠
u = (-1+sqrt(5))/2
v = (-1-sqrt(5))/2
k=11
float((u^k-v^k)/sqrt(5))
︡f1a56136-f9bb-4bb1-a8b7-97bc0b293303︡{"stdout":"89.00000000000004\n"}︡{"done":true}︡
︠2173ef71-d020-4b5d-b656-7b9feb4a34ecs︠
solve(1-x-x^2-x^3==0,x)
︡2b931a71-0bd2-461f-afa2-fe0d5e3aae30︡{"stdout":"[x == -1/2*(1/9*sqrt(11)*sqrt(3) + 17/27)^(1/3)*(I*sqrt(3) + 1) + 1/9*(-I*sqrt(3) + 1)/(1/9*sqrt(11)*sqrt(3) + 17/27)^(1/3) - 1/3, x == -1/2*(1/9*sqrt(11)*sqrt(3) + 17/27)^(1/3)*(-I*sqrt(3) + 1) - 1/9*(-I*sqrt(3) - 1)/(1/9*sqrt(11)*sqrt(3) + 17/27)^(1/3) - 1/3, x == (1/9*sqrt(11)*sqrt(3) + 17/27)^(1/3) - 2/9/(1/9*sqrt(11)*sqrt(3) + 17/27)^(1/3) - 1/3]\n"}︡{"done":true}︡
︠90749d58-4ca9-46b5-ab0c-76bad3bd5fc6s︠


mod(24^37,77)
︡e9616a49-b2f2-47d1-8137-db6379e3450f︡{"stdout":"73\n"}︡{"done":true}︡
︠53de32ad-b777-4f3e-be38-7fbff5534a12s︠
mod(73^13,77)
︡1d8ccacc-ef36-4855-8eb4-c4979f31ece3︡{"stdout":"24\n"}︡{"done":true}︡
︠d1178dee-2855-4243-8071-799c261d7d34︠









